<?php

class bbr_Theme_Options {
	
	private $sections;
	private $widgetsections;
	private $aboutsections;
	private $widgetoptions;
	private $checkboxes;
	private $selcheckboxes;
	
	public function __construct() {
		
		$this->checkboxes = array();
		$this->selcheckboxes = array();
		
		$this->sections['link_color']      = __( 'Link Color', BBR_TEXT_DOMAIN );
		$this->sections['category_color']   = __( 'Category Color', BBR_TEXT_DOMAIN );
		$this->sections['tag_color'] = __( 'Tag Color', BBR_TEXT_DOMAIN );
		$this->sections['page_color']  = __( 'Page Color', BBR_TEXT_DOMAIN );
		
		$this->aboutsections['uses']  = __( 'Uses', BBR_TEXT_DOMAIN );
		$this->aboutsections['short_code']  = __( 'Short Code', BBR_TEXT_DOMAIN );
		$this->aboutsections['about']  = __( 'About', BBR_TEXT_DOMAIN );
		
		$this->sections['page_color']  = __( 'Page Color', BBR_TEXT_DOMAIN );
		
		add_action( 'admin_menu', array( &$this, 'add_pages' ) );
		add_action( 'admin_init', array( &$this, 'register_settings' ) );
		add_action( 'admin_head', array( &$this, 'admin_css' ) );
		
	}

	public function add_pages() {
		$ring_page =add_menu_page(  __( 'BillyBen Rings', BBR_TEXT_DOMAIN ), __( 'BillyBen Rings', BBR_TEXT_DOMAIN ), 'manage_options', 'bbr-widget-options', array( &$this, 'display_ring_page' )) ;
		$color_page= add_submenu_page('bbr-widget-options', __( 'BBR Colors Options', BBR_TEXT_DOMAIN ), __( 'BBR Colors Options', BBR_TEXT_DOMAIN ), 'manage_options', 'bbr-options', array( &$this, 'display_page' ) );
		$help_page=add_submenu_page('bbr-widget-options', __( 'Help', BBR_TEXT_DOMAIN ), __( 'Help', BBR_TEXT_DOMAIN ), 'manage_options', 'help-options', array( &$this, 'display_help_page' ) );
		
		add_action( 'admin_print_scripts-' . $ring_page, array( &$this, 'scripts' ) );
		add_action( 'admin_print_scripts-' . $color_page, array( &$this, 'scripts' ) );
		add_action( 'admin_print_scripts-' . $help_page, array( &$this, 'scripts' ) );
		
	}

	
	public function display_ring_page() {
		
		$path2=$this->curPageURL();
		echo '<div class="wrap">
	<div class="icon32" id="icon-options-general"></div>
	<h2>' . __( 'BB Ring Options', BBR_TEXT_DOMAIN ) . '</h2>';
	echo '<form style="display:inline;" action="'.$path2.'" method="post" >';
	echo '<input type="submit" class="button-secondary" name="createWidget" value="' . __( 'Create New', BBR_TEXT_DOMAIN ) . '"/>';
	echo '</form>';
	echo '<form style="display:inline;" action="'.$path2.'" method="post" onsubmit="return bbr_confirmErase(\''.__('You will Erase Widget',  BBR_TEXT_DOMAIN).'\')">';
	echo '<input type="hidden" class="button-secondary" name="eraseWidget" id="bbreraseWidget" value="' . __( 'Erase Current', BBR_TEXT_DOMAIN ) . '"/>';
	echo '<input type="hidden" id="bbr_idOfCurrentWidget" name="bbr_idOfCurrentWidget" value=""/>';
	echo '</form><br/><br/>';
	echo '<form action="options.php" method="post" onsubmit="return bbr_validateRingForm(this)">';
	
		settings_fields( 'bbr_widget_opt' );
		echo '<div class="ui-tabs">
			<ul class="ui-tabs-nav">';
		
		foreach ( $this->widgetoptions as $section )
			echo '<li><a href="#' . strtolower( str_replace( ' ', '_', $section ) ) . '" onclick="currentWidgetHasChange(this)">' . $section . '</a></li>';
		
		echo '</ul>';
		echo '<input name="Submit" type="submit" class="button-primary" value="' . __( 'Save Changes', BBR_TEXT_DOMAIN ) . '" />';
		do_settings_sections( $_GET['page'] );	
		echo '</div>';
		echo '<p class="submit"><input name="Submit" type="submit" class="button-primary" value="' . __( 'Save Changes', BBR_TEXT_DOMAIN ) . '" /></p>';
		
		
	echo '</form>';
	echo	'<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/BillyBenRing/elm/js/bbr_js.js"></script>';
	echo	'<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/BillyBenRing/elm/js/jscolor.js"></script>';
	echo	'</div>';
	}
	
	
	public function display_page() {
		
		echo '<div class="wrap">
	<div class="icon32" id="icon-options-general"></div>
	<h2>' . __( 'BB Ring Colors Options', BBR_TEXT_DOMAIN ) . '</h2>
	<form action="options.php" method="post">';
	
		settings_fields( 'bbr_options' );
		echo '<div class="ui-tabs">
			<ul class="ui-tabs-nav">';
		
		foreach ( $this->sections as $section )
			echo '<li><a href="#' . strtolower( str_replace( ' ', '_', $section ) ) . '">' . $section . '</a></li>';
		
		echo '</ul>';
		echo '<input name="Submit" type="submit" class="button-primary" value="' . __( 'Save Changes', BBR_TEXT_DOMAIN ) . '" />';
		do_settings_sections( $_GET['page'] );
		
		echo '</div>';
		echo '<p class="submit"><input name="Submit" type="submit" class="button-primary" value="' . __( 'Save Changes', BBR_TEXT_DOMAIN ) . '" /></p>';
		
		echo '<input type="hidden" name="bbr_options[bbr_currLang]" value="'.(( function_exists('icl_get_languages') )?ICL_LANGUAGE_CODE:"en").'"></input>';
		
	echo '</form>';
	echo	'<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/BillyBenRing/elm/js/bbr_js.js">
			bbr_enable_color_tab();
	</script>';
	echo	'<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/BillyBenRing/elm/js/jscolor.js"></script>';
	echo	'</div>';
		
	}
	
	public function display_link_section($args){
		$options=get_option( 'bbr_options' );
		echo '<table class="to_ft">';
		echo '<tbody>';		
		
		$cats =  bbr_get_bookmark_tag_arr();
	foreach (  $cats as $catName=>$catIDs ) {
			$catId="link_cat_id_".$catIDs;
				echo '<th scope="row"><label for="'.$catId.'">'.$catName.'</label></th><td>';
				echo '<input class="regular-text color" type="text" id="' . $catId . '" name="bbr_options[' . $catId . ']"  value="' . $options[$catId] . '" size="6"/></td></tr>';
		}
		
		
		echo '<tr valign="top" style="">';
		echo '<th scope="row">
			<label for="link_dest">Select Link destination</label>
			</th><td>';
		echo '<select class="select.select" name="bbr_options[link_dest]">';
		echo '<option value="_self"' . selected($options['link_dest'],"_self", false). '>' .  __("current window", BBR_TEXT_DOMAIN) . '</option>';
		echo '<option value="_blank"' . selected($options['link_dest'],"_blank", false). '>' .  __("new window", BBR_TEXT_DOMAIN) . '</option>';
		echo '</select></tr>';		 
		echo '</td></tr><tr valign="top"><td colspan="2">';
					echo '<input class="color" type="text" id="linkGradient1" name="bbr_options[linkGradient1]"  value="' . $options['linkGradient1'] . '" size="6"/>';
					echo '<input class="color" type="text" id="linkGradient2" name="bbr_options[linkGradient2]"  value="' . $options['linkGradient2'] . '" size="6"/>';
					echo '<input id="linkGradientButton" name="bbr_options[linkGradientButton]" type="button" value="'.__('Create Gradient', BBR_TEXT_DOMAIN).'" onClick="bbr_createGradient(this)"/>';
					echo '</td></tr>';
		echo '<th scope="row"><td/>
			
			<input type="checkbox" class="selectAll_CB">
			<label>Select/deselect All</label>
			</td></tr>';
						echo '</table>';
		
	}

	public function display_section($args) {
		$pId=$args['id'];
		switch ($pId){
			case 'category_color' :
				$id='cat';
			break;
			case 'tag_color' :
				$id='tag';
			break;	
			case 'page_color' :
				$id='page';
			break;	
		}
	
	$options=get_option( 'bbr_options' );
		echo '<table class="to_ft">';
		echo '<tbody>';		
		
		echo '<tr valign="top" style="">';
		echo '<th scope="row">
			<label for="'.$id.'_dest">Select Link destination</label>
			</th><td>';
		echo '<select class="select.select" name="bbr_options['.$id.'_dest]">';
		echo '<option value="_self"' . selected($options[$id.'_dest'],"_self", false). '>' .  __("current window", BBR_TEXT_DOMAIN) . '</option>';
		echo '<option value="_blank"' . selected($options[$id.'_dest'],"_blank", false). '>' .  __("new window", BBR_TEXT_DOMAIN) . '</option>';
		echo '</select></tr>';		 
		echo '</td></tr><tr valign="top"><td colspan="2">';
					echo '<input class="color" type="text" id="'.$id.'Gradient1" name="bbr_options['.$id.'Gradient1]"  value="' . $options[$id.'Gradient1'] . '" size="6"/>';
					echo '<input class="color" type="text" id="'.$id.'Gradient2" name="bbr_options['.$id.'Gradient2]"  value="' . $options[$id.'Gradient2'] . '" size="6"/>';
					echo '<input id="'.$id.'GradientButton" name="bbr_options['.$id.'GradientButton]" type="button" value="'.__('Create Gradient', BBR_TEXT_DOMAIN).'" onClick="bbr_createGradient(this)"/>';
					echo '</td></tr>';
					echo '<th scope="row"><td/>
			
			<input type="checkbox" class="selectAll_CB">
			<label>Select/deselect All</label>
			</td></tr>';
						echo '</table>';						
		
	}
	public function display_ring_section($args) {
		$path=get_bloginfo('wpurl')."/wp-content/plugins/BillyBenRing/" ;
		//foreach ($args as $k=>$v)echo '<p> args :'.$k."/".$v."</p>";
		$divId=$args["id"];
		$wId=substr($args["id"], strrpos ( $args["id"], "_")+1);
		$instOpt['wid']=$wId;
		$widget=new BillyBenRing();
		$widget->_set($divId);
		$fashId=$widget->get_field_id('flashContentId');
		echo '<script type="text/javascript" src="'.$path.'elm/js/swfobject.js"></script>';
		echo '<table>';
		echo '<td> <input class="bbr_updateFlashPreview" type="button" value="Update Preview" /></td>';//onclick="bbr_updatePreview(this, \''.$fashId.'\')"
		echo '<td>';
		$widget->widget(array(), $instOpt);
		echo '</div>';		
		echo '</table>';
				
	}
	
	 public function display_ring_setting( $args = array() ) {
		
		extract( $args );
		$options = get_option( 'bbr_widget_opt' );		
		
		if ( !isset( $options[$id] ) && 'type' != 'checkbox' )
			$options[$id] = $std;
		
		$field_class = '';
		if ( $class != '' )
			$field_class = ' ' . $class;
		
		switch ( $type ) {
			
			case 'heading':
				echo '</td></tr><tr valign="top"><td colspan="2">' . $desc;
				break;
			
			case 'checkbox':
				
				echo '<input class="checkbox' . $field_class . '" type="checkbox" id="' . $id . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" value="1" ' . checked( $options[$wid][$id], 1, false ) . ' /> <label for="' . $id . '">' . $desc . '</label>';
				
				break;
			
			case 'select':
				echo '<select class="select' . $field_class . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" id="'.$id.'">';
				
				foreach ( $choices as $value => $label )
					echo '<option value="'.$value.'"' . selected($options[$wid][$id],$value, false). '>' . $label . '</option>';
				
				echo '</select>';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'radio':
				$i = 0;
				foreach ( $choices as $value => $label ) {
					echo '<input class="radio' . $field_class . '" type="radio" name="bbr_widget_opt['.$wid.'][' . $id . ']" id="' . $id . $i . '" value="' . $value . '" ' 
					.checked($options[$wid][$id],$value, false). '> <label for="' . $id . $i . '">' . $label . '</label>';
					if ( $i < count( $options ) - 1 )
						echo '<br />';
					$i++;
				}
				
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'textarea':
				echo '<textarea class="' . $field_class . '" id="' . $id . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" placeholder="' . $std . '" rows="5" cols="30">' . $options[$wid][$id] . '</textarea>';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'password':
				echo '<input class="regular-text' . $field_class . '" type="password" id="' . $id . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" value="' . $options[$wid][$id] . '" />';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			case 'colorText':
					echo '<input class="regular-text' . $field_class . '" type="text" id="' . $id . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" placeholder="' . $std . '" value="' . $options[$wid][$id] . '" size="6"/>';
			
				break;
			case 'GradientcolorText':
					echo '</td></tr><tr valign="top"><td colspan="2">';
					echo '<input class="' . $field_class . '" type="text" id="' . $id . '1" name="bbr_widget_opt['.$wid.'][' . $id . '1]" placeholder="' . $std . '" value="' . $options[$wid][$id."1"] . '" size="6"/>';
					echo '<input class="' . $field_class . '" type="text" id="' . $id . '2" name="bbr_widget_opt['.$wid.'][' . $id . '2]" placeholder="' . $std . '" value="' . $options[$wid][$id."2"] . '" size="6"/>';
					echo '<input id="'.$id.'Button" name="bbr_widget_opt['.$wid.'][' . $id . 'Button]" type="button" value="'.__('Create Gradient', BBR_TEXT_DOMAIN).'" onClick="bbr_createGradient(this)"/>';
					echo '</td></tr><tr valign="top"><td colspan="2">';
				break;
				
			case 'infoText' :
				echo '<tr/><span class="description">' . $desc . '</span>';
			break;
			
			case 'text':
			default:
		 		echo '<input class="regular-text' . $field_class . '" type="text" id="' . $id . '" name="bbr_widget_opt['.$wid.'][' . $id . ']" placeholder="' . $std . '" value="' . $options[$wid][$id] . '" />';
		 		if ( $desc != '' )
		 			echo '<br /><span class="description">' . $desc . '</span>';
		 		
		 		break;
		 	
		}
		
	}
	public function display_setting( $args = array() ) {
		
		extract( $args );
		
		$options = get_option( 'bbr_options' );
		
		if ( !isset( $options[$id] ) && 'type' != 'checkbox' )
			$options[$id] = $std;
		
		$field_class = '';
		if ( $class != '' )
			$field_class = ' ' . $class;
		
		switch ( $type ) {
			
			case 'heading':
				echo '</td></tr><tr valign="top"><td colspan="2">' . $desc;
				break;
			
			case 'checkbox':
				
				echo '<input class="checkbox' . $field_class . '" type="checkbox" id="' . $id . '" name="bbr_options[' . $id . ']" value="1" ' . checked( $options[$id], 1, false ) . ' /> <label for="' . $id . '">' . $desc . '</label>';
				
				break;
			
			case 'select':
				echo '<select class="select' . $field_class . '" name="bbr_options[' . $id . ']">';
				
				foreach ( $choices as $value => $label )
					echo '<option value="'.$value.'"' . selected($options[$id],$value, false). '>' . $label . '</option>';
				echo '</select>';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'radio':
				$i = 0;
				foreach ( $choices as $value => $label ) {
					echo '<input class="radio' . $field_class . '" type="radio" name="bbr_options[' . $id . ']" id="' . $id . $i . '" value="' . $value . '" ' . checked( $options[$id], $value, false ) . '> <label for="' . $id . $i . '">' . $label . '</label>';
					if ( $i < count( $options ) - 1 )
						echo '<br />';
					$i++;
				}
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'textarea':
				echo '<textarea class="' . $field_class . '" id="' . $id . '" name="bbr_options[' . $id . ']" placeholder="' . $std . '" rows="5" cols="30">' . $options[$id] . '</textarea>';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			
			case 'password':
				echo '<input class="regular-text' . $field_class . '" type="password" id="' . $id . '" name="bbr_options[' . $id . ']" value="' . $options[$id] . '" />';
				
				if ( $desc != '' )
					echo '<br /><span class="description">' . $desc . '</span>';
				
				break;
			case 'colorText':
					echo '<input class="regular-text' . $field_class . '" type="text" id="' . $id . '" name="bbr_options[' . $id . ']" placeholder="' . $std . '" value="' . $options[$id] . '" size="6"/>';
					echo '<input type="hidden" class="col_pos" id="' . $id . '_pos" name="bbr_options[' . $id . '_pos]" value="' . $options[$id.'_pos'] . '" />';
					echo '<input type="checkBox" class="col_sel" id="'.$id.'_sel" name="bbr_options['.$id.'_sel]"  '.checked(isset($options[$id.'_sel']), 1, false).'" value="1"/>';
					$this->selcheckboxes[]=$id."_sel";
				break;
			case 'GradientcolorText':
					echo '</td></tr><tr valign="top"><td colspan="2">';
					echo '<input class="' . $field_class . '" type="text" id="' . $id . '1" name="bbr_options[' . $id . '1]" placeholder="' . $std . '" value="' . $options[$id."1"] . '" size="6"/>';
					echo '<input class="' . $field_class . '" type="text" id="' . $id . '2" name="bbr_options[' . $id . '2]" placeholder="' . $std . '" value="' . $options[$id."2"] . '" size="6"/>';
					echo '<input id="'.$id.'Button" name="bbr_options[' . $id . 'Button]" type="button" value="'.__('Create Gradient', BBR_TEXT_DOMAIN).'" onClick="bbr_createGradient(this)"/>';
					echo '</td></tr><tr valign="top"><td colspan="2">';
				break;
			
			case 'text':
			default:
		 		echo '<input class="regular-text' . $field_class . '" type="text" id="' . $id . '" name="bbr_options[' . $id . ']" placeholder="' . $std . '" value="' . $options[$id] . '" />';
		 		if ( $desc != '' )
		 			echo '<br /><span class="description">' . $desc . '</span>';
		 		
		 		break;
		 	
		}
		
	}
	
	public function createNewWidget(){
		$options=get_option('bbr_widget_opt');
		$lastId=$options['lastId'];
		$lastId++;
		$options['lastId']=$lastId;
		$options['allId'][]=$lastId;
		$options[$lastId]=bbr_init_single_widget_options(array());
		update_option('bbr_widget_opt', $options);
	}
	public function eraseWidget(){
		$id=$_POST['bbr_idOfCurrentWidget'];
		$options=get_option('bbr_widget_opt');
		$i=$this->indexOf($id, $options['allId']);
		if(!$i)return;
		array_splice ($options['allId'], $i, 1);
		unset($options[$id]);
		update_option('bbr_widget_opt', $options);
	}
	
	public function register_settings() {
		if (isset($_POST['createWidget']))$this->createNewWidget();
		if (isset($_POST['eraseWidget']))$this->eraseWidget();	
		
		register_setting( 'bbr_options', 'bbr_options', array ( &$this, 'validate_settings' ) );
		register_setting( 'bbr_widget_opt', 'bbr_widget_opt', array ( &$this, 'validate_widget_settings' ) );
		
		add_settings_section( 'link_color', $this->sections['link_color'], array( &$this, 'display_link_section' ), 'bbr-options' );
		add_settings_section( 'category_color', $this->sections['category_color'], array( &$this, 'display_section' ), 'bbr-options' );
		add_settings_section( 'tag_color', $this->sections['tag_color'], array( &$this, 'display_section' ), 'bbr-options' );
		add_settings_section( 'page_color', $this->sections['page_color'], array( &$this, 'display_section' ), 'bbr-options' );
		
		
		add_settings_section( 'uses', $this->aboutsections['uses'], array( &$this, 'display_uses_section' ), 'help-options' );
		add_settings_section( 'short_code', $this->aboutsections['short_code'], array( &$this, 'display_shortcode_section' ), 'help-options' );
		add_settings_section( 'about', $this->aboutsections['about'], array( &$this, 'display_about_section' ), 'help-options' );
		
		/* setting des ring
		===========================================*/
		$widget_opt=get_option('bbr_widget_opt');
		foreach($widget_opt as $key=>$value){			
			if($key==='allId'||$key==='lastId')continue;
			
			$this->widgetoptions['wiget_'.$key]='Widget '.$key;
			add_settings_section( 'wiget_'.$key, 'Widget '.$key, array( &$this, 'display_ring_section' ), 'bbr-widget-options' );
			
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => '',
			'title'   => '',
			'desc'    => '[BBR id="'.$key.'" align="middle"]',
			'std'     => '',
			'type'    => 'infoText',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'width',
			'title'   => __( 'Width' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'height',
			'title'   => __( 'Height' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'ringSize',
			'title'   => __( 'Rings thickness' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'firstRingSize',
			'title'   => __( 'First Ring Size' , BBR_TEXT_DOMAIN),
			'desc'    => __( 'first ring inner radius' , BBR_TEXT_DOMAIN),
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'circlePos',
			'title'   => __( 'Position of rings' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'select',
			'section' => 'wiget_'.$key,
			'choices' => array(
							"0"=>__( 'middle' , BBR_TEXT_DOMAIN),
							"1"=>__( 'left' , BBR_TEXT_DOMAIN),
							"2"=>__( 'top' , BBR_TEXT_DOMAIN),
							"3"=>__( 'right' , BBR_TEXT_DOMAIN),
							"4"=>__( 'bottom' , BBR_TEXT_DOMAIN),
							"5"=>__( 'top left' , BBR_TEXT_DOMAIN),
							"6"=>__( 'top right' , BBR_TEXT_DOMAIN),
							"7"=>__( 'bottom right' , BBR_TEXT_DOMAIN),
							"8"=>__( 'bottom left' , BBR_TEXT_DOMAIN)							
						)
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'transparent',
			'title'   => __( 'Hide BackGround' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'bgColor',
			'title'   => __( 'Background Color' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'colorText',
			'class'   => 'color',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'txtOffColor',
			'title'   => __( 'Text Color off' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'colorText',
			'class'   => 'color',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' ); 
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'txtOnColor',
			'title'   => __( 'Text Color over' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'colorText',
			'class'   => 'color',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' ); 
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'overGlowColor',
			'title'   => __( 'Over Glow Color' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'colorText',
			'class'   => 'color',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' ); 
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'deltaRing',
			'title'   => __( 'Space between rings' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'RingCrop',
			'title'   => __( 'Ring fit text' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'radio',
			'section' => 'wiget_'.$key,
			'choices' => array(
							"ENTIRE"=>__( 'Entire' , BBR_TEXT_DOMAIN),
							"FIT"=>__( 'Fit' , BBR_TEXT_DOMAIN)
						)
			), 'display_ring_setting' );
			
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'startAngle',
			'title'   => __( 'Start Angle' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'startAlign',
			'title'   => __( 'Start Alignement' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'radio',
			'section' => 'wiget_'.$key,
			'choices' => array(
							"ALIGN"=>__( 'Align' , BBR_TEXT_DOMAIN),
							"RANDOM"=>__( 'Random' , BBR_TEXT_DOMAIN),							
							"DECAL"=>__( 'Decal' , BBR_TEXT_DOMAIN)
						)
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'decalAngle',
			'title'   => __( 'Decal Alignement' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'text',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'textAlign',
			'title'   => __( 'Text Alignement' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'radio',
			'section' => 'wiget_'.$key,
			'choices' => array(
							"0"=>__( 'In' , BBR_TEXT_DOMAIN),
							"1"=>__( 'Along left' , BBR_TEXT_DOMAIN),	
							"2"=>__( 'Out' , BBR_TEXT_DOMAIN),						
							"3"=>__( 'Along Right' , BBR_TEXT_DOMAIN)
						)
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'displayLink',
			'title'   => __( 'Display Links' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'displayLinkTag',
			'title'   => __( 'Display Links Tags' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'displayCat',
			'title'   => __( 'Display Cat' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'displayKeyWord',
			'title'   => __( 'Display Tag' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			$this->create_ring_setting( array(
			'wid'	  => $key,
			'id'      => 'displayPage',
			'title'   => __( 'Display Page' , BBR_TEXT_DOMAIN),
			'desc'    => '',
			'std'     => '',
			'type'    => 'checkbox',
			'section' => 'wiget_'.$key
			), 'display_ring_setting' );
			
			
			
			
		}		
		
		
		/* links color
		===========================================*/ 
		
		$cats = bbr_get_bookmark_arr_order();
		foreach (  $cats as $bm) {
			  $catId="link_id_".$bm->link_id;
			  $catName=$bm->catName;
			  $this->create_setting( array(
					'section' => 'link_color',
					'id'      => $catId,
					'title'   => '('.$catName.') '.$bm->link_name,
					'desc'    => '',
					'type'    => 'colorText',
					'std'     => '',
					'class' => 'color'
				) );		  
	 	 }
		
		 
		 
		 /* cat color
		===========================================*/
				
		$cats=bbr_get_category_arr_order();
		foreach($cats as $cat){
		$catId="cat_id_".$cat->term_id;
			  $this->create_setting( array(
					'section' => 'category_color',
					'id'      => $catId,
					'title'   => $cat->name,
					'desc'    => '',
					'type'    => 'colorText',
					'std'     => '',
					'class' => 'color'
				) );			
		}
		
		/* tag color
		===========================================*/
		$cats=bbr_get_keywords_arr_order();
		foreach ( $cats as $tag ) {
				$catId="tag_id_".$tag["id"];
				$key=$tag["tagName"];
				$this->create_setting( array(
					'section' => 'tag_color',
					'id'      => $catId,
					'title'   => $key,
					'desc'    => '',
					'type'    => 'colorText',
					'std'     => '',
					'class' => 'color'
				) );
				
			}
		/* page color
		===========================================*/
		$cats=bbr_get_page_arr_order();
		foreach ( $cats as  $tag ) {
				$catId="page_id_".$tag["id"];
				$this->create_setting( array(
					'section' => 'page_color',
					'id'      => $catId,
					'title'   => $tag["name"],
					'desc'    => '',
					'type'    => 'colorText',
					'std'     => '',
					'class' => 'color'
				) );				
			}		
		}

	public function create_setting( $args = array(), $innerCallBack='display_setting' ) {
		
		$defaults = array(
			'id'      => 'default_field',
			'title'   => __( 'Default Field', BBR_TEXT_DOMAIN ),
			'desc'    => __( 'This is a default description.', BBR_TEXT_DOMAIN ),
			'std'     => '',
			'type'    => 'text',
			'section' => 'general',
			'choices' => array(),
			'class'   => ''
		);
			
		extract( wp_parse_args( $args, $defaults ) );
		
		$field_args = array(
			'type'      => $type,
			'id'        => $id,
			'desc'      => $desc,
			'std'       => $std,
			'choices'   => $choices,
			'label_for' => $id,
			'class'     => $class
		);
		
		add_settings_field( $id, $title, array( $this, $innerCallBack ), 'bbr-options', $section, $field_args );
		
		if ( $type == 'checkbox' )
			$this->selcheckboxes[] = $id;
		
	}
	public function create_ring_setting( $args = array(), $innerCallBack='display_setting' ) {
		
		$defaults = array(
			'wid'     => 0,
			'id'      => 'default_field',
			'title'   => __( 'Default Field', BBR_TEXT_DOMAIN ),
			'desc'    => __( 'This is a default description.', BBR_TEXT_DOMAIN ),
			'std'     => '',
			'type'    => 'text',
			'section' => 'general',
			'choices' => array(),
			'class'   => ''
		);
			
		extract( wp_parse_args( $args, $defaults ) );
		
		$field_args = array(
			'type'      => $type,
			'id'        => $id,
			'desc'      => $desc,
			'std'       => $std,
			'choices'   => $choices,
			'label_for' => $id,
			'class'     => $class,
			'wid'       => $wid
		);
		
		add_settings_field( $id, $title, array( $this, $innerCallBack ), 'bbr-widget-options', $section, $field_args );
		
		if ( $type == 'checkbox' )
			$this->checkboxes[$wid][] = $id;
		
	}
	
	public function scripts() {
		
		wp_enqueue_script( 'jquery-ui-tabs' );
		wp_enqueue_script('jquery-ui-sortable');
		
	}
	public function admin_css() {
		 $path=get_bloginfo('wpurl')."/wp-content/plugins/BillyBenRing/elm/" ;
		if ( isset( $_GET['page'] ) && ($_GET['page'] == 'bbr-options'||$_GET['page'] == 'bbr-widget-options'||$_GET['page'] == 'help-options') )
			echo '<link rel="stylesheet" href="' . $path . 'bbr_style.css" />' . "\n";
		
	}
	
	public function validate_widget_settings( $input ) {
		
		
		$options = get_option( 'bbr_widget_opt' );
		
		foreach ( $this->checkboxes as $cbs=>$num ) {
			foreach ($num as $key=>$id){
				$input[$cbs][$id]=	(isset($input[$cbs][$id]))?true:false;
			}
		}
		$input['allId']=$options['allId'];
		$input['lastId']=$options['lastId'];
		
		
		return $input;
		
	}
	
	public function validate_settings( $input ) {
		$c=count($this->selcheckboxes);
		for ($i=0; $i<$c; $i++){
			$idCB=	$this->selcheckboxes[$i];
			$input[$idCB]=(isset($input[$idCB]))?true:false;
			$input['cat_id_1_sel']=true;
		}				
		return $input;		
	}
	
	
	function curPageURL() {
		 $pageURL = 'http';
		  if (isset($_SERVER["HTTPS"])&& $_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
		 $pageURL .= "://";
		if ($_SERVER["SERVER_PORT"] != "80") {
		  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
		 } else {
		  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		 }
		 return $pageURL;
	}
	function indexOf($value, $arr) {               
        for ($i=0;$i<count($arr);$i++) {         
                if ($arr[$i] == $value) {      
                        return $i;                    
                }
        }
        return false;
}

/* page d'aides
_______________________ */
public function display_help_page() {
	echo '<div class="wrap">
	<div class="icon32" id="icon-options-general"></div>
	<h2>' . __( 'BB Ring Help', BBR_TEXT_DOMAIN ) . '</h2>';
	settings_fields( 'bbr_options' );
	echo '<div class="ui-tabs">
			<ul class="ui-tabs-nav">';
	foreach ( $this->aboutsections as $section )
			echo '<li><a href="#' . strtolower( str_replace( ' ', '_', $section ) ) . '" onclick="currentWidgetHasChange(this)">' . $section . '</a></li>';
	echo '</ul>';
	do_settings_sections( $_GET['page'] );
	echo '</div>';
	echo	'<script type="text/javascript">
		jQuery(document).ready(function($) {
			var wrapped = $(".wrap h3").wrap("<div class=\"ui-tabs-panel\">");
			wrapped.each(function() {
				$(this).parent().append($(this).parent().nextUntil("div.ui-tabs-panel"));
			});
			$(".ui-tabs-panel").each(function(index) {
				var str = $(this).children("h3").text().replace(/\s/g, "_");
				$(this).attr("id", str.toLowerCase());
				if (index > 0)
					$(this).addClass("ui-tabs-hide");
			});
			$(".ui-tabs").tabs({ fx: { opacity: "toggle", duration: "fast" } });
			
			$("input[type=text], textarea").each(function() {
				if ($(this).val() == $(this).attr("placeholder") || $(this).val() == "")
					$(this).css("color", "#999");
			});
			
			$("input[type=text], textarea").focus(function() {
				if ($(this).val() == $(this).attr("placeholder") || $(this).val() == "") {
					$(this).val("");
					$(this).css("color", "#000");
				}
			}).blur(function() {
				if ($(this).val() == "" || $(this).val() == $(this).attr("placeholder")) {
					$(this).val($(this).attr("placeholder"));
					$(this).css("color", "#999");
				}
			});
			
			$(".wrap h3, .wrap table").show();
		});
	</script>';
	echo	'</div>';
	
	
}
function display_uses_section(){
	echo '<ul class="bbrList">';
	echo '<li>'. __( "You can define each rings displayed colors at the <i>'BBR colors options'</i> panel ", BBR_TEXT_DOMAIN ).'</li>';
	echo '<ul class="bbrSubList">';
	echo '<li>'. __( "Just Click on the text to display a colorPicker", BBR_TEXT_DOMAIN ).'</li>';
	echo '<li>'. __( "You can create a color gradient : Choose the two colors and click <i>'Create Gradient'</i>", BBR_TEXT_DOMAIN ).'</li>';
	echo '</ul>';
	echo '<li>'. __( "Choose item order at <i>'BBR colors options'</i> panel simply by drang'n'drop item", BBR_TEXT_DOMAIN ).'</li>';
	echo '<li>'. __( "Choose which item you want to display at <i>'BBR colors options'</i> panel by check/uncheck checkboxes", BBR_TEXT_DOMAIN ).'</li>';
	echo '<li>'. __( "Create A widget definition at the <i>'BillyBen Rings'</i> panel", BBR_TEXT_DOMAIN ).'<br/> it will generate a unique id (after the term "Widget_" that you will need later)</li>';
	echo '<li>'. __( "At the <i>Widget Panel</i>, drag'n'drop a BillyBen Ring into your side bar, and define the title (or not) and the Widget Id corresponding to the Widget Id define previously", BBR_TEXT_DOMAIN ).'</li>';
	echo '<li>'. __( "For Short code uses please refer to the <i>'Short Code'</i> section", BBR_TEXT_DOMAIN ).'</li>';
	echo '</ul>';
	
}
function display_shortcode_section(){
	echo '<h4>'. __( "Basic ShorCode Uses", BBR_TEXT_DOMAIN ).'</h4>';
	echo '<p> <span>'.__('BB Ring can be displayed in each post by shortcode using',BBR_TEXT_DOMAIN ).' </span></p>';
	echo '<p>'.__('Simple shortcode example',BBR_TEXT_DOMAIN ).' : [BBR id="X"] <span class="description">where \'X\' figure a widget id</span></p>';
	echo '<p>'.__('Insert this into your post',BBR_TEXT_DOMAIN ).'</p>';
	echo '<p>'.__('Extended shortcode example',BBR_TEXT_DOMAIN ).' : [BBR id="X" aling="left"] <span class="description">aling accept "left", "right" and "middle"</span></p>';
	echo '<br/>';
	echo '<h4 style="display:inline;">'. __( "Advanced ShorCode Uses", BBR_TEXT_DOMAIN ).'  </h4><span class="description">'.__('expert user',BBR_TEXT_DOMAIN ).'</span>';
	echo '<p> <span>'.__('BBR Shortcode allows the change of every Ring option define in Option table',BBR_TEXT_DOMAIN ).' </span></p>';
	echo '<p>'.__('Example',BBR_TEXT_DOMAIN ).' : [BBR id="X" aling="left" ringSize="12" width="55" height="70" RingCrop="_fit"]</p>';
	
	echo '<table class="bbr-table">';
	echo '<tr valign="top"><th scope="row" colspan="2" align="left">'.__("Attibutes Description", BBR_TEXT_DOMAIN).'</th></tr>';
	echo '<td align="RIGHT" class="firstCol">'.__("width", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('width of the swf',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("height", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('height of the swf',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("ringSize", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('ring thickness',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("firstRingSize", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('first ring inner radius',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("circlePos", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('Rings Center position (middle, left, top.....)',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number : [0 -> 8]',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("txtOffColor", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('text color off',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept 6 digit/letter HEX value (e.g 34AE00)',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("txtOnColor", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('text color on',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept 6 digit/letter HEX value (e.g 34AE00)',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("overGlowColor", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('ring glow color',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept 6 digit/letter HEX value (e.g 34AE00)',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("deltaRing", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('space between rings',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("RingCrop", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('define arrowed or entire circle ring',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept "ENTIRE" or "FIT"',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("startAlign", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('alignement of rings',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept "ALIGN", "DECAL" or "RANDOM"',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("startAngle", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('start angle for rings alignement',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("decalAngle", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('shift of start angle for rings alignement',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	echo '<td align="RIGHT">'.__("textAlign", BBR_TEXT_DOMAIN).'</td><td align="LEFT">-'.__('alignement of text along the circle',BBR_TEXT_DOMAIN ).'</td><td><span class="description">'.__('accept number : "0", "1", "2", or "3"',BBR_TEXT_DOMAIN ).'</span></td></tr>';
	
	echo '</table>';
	echo '<h5>'.__("Warning ", BBR_TEXT_DOMAIN).': <span class="description">'.__("Entering wrong values will cause the crash of the widet (you will see the get adobet picture) ", BBR_TEXT_DOMAIN).'</span></h5>';
	
}
function display_about_section(){
	$copyright_year = ( date( 'Y' ) == '2011' ? '2011' : '2011&ndash;' . date( 'Y' ) );
		
		echo '<h4>' . sprintf( __( 'Billy Ben Ring %s version %s', BBR_TEXT_DOMAIN ), '<small class="quiet">', BBR_VERSION_NUM ) . '</small></h4>';
		echo '<p><span class="description"> Author <a href="http://asblog.etherocliquecite.eu" target="_blank" title="' . __( 'Visit BillyBen Page', BBR_TEXT_DOMAIN ) . '">BillyBen</a></span></p>';
		
		echo '<p>&copy;' . $copyright_year . ' <a href="http://82.228.191.29/asblog/?page_id=488&lang=en" target="_blank" title="' . __( 'Visit BBR Page', BBR_TEXT_DOMAIN ) . '">BBR Page</a>.
		
		' . sprintf( __( 'BB Ring is licensed under the %s GNU General Public License version 2.0%s', BBR_TEXT_DOMAIN ), '<a href="http://www.gnu.org/licenses/gpl-3.0-standalone.html">', '</a>.</p>' );
		echo '<h4>' . __( 'Extra Code', BBR_TEXT_DOMAIN ) . '</small></h4>';
		echo '<p> Color Picker by <a href="http://odvarko.cz/">Jan Odvarko</a> (<a href="http://jscolor.com/">jscolor</a>)</p>';
		echo '<p> Great Thanks to  <a href="http://alisothegeek.com/">Aliso the Geek</a> and its fantastic tutorial about WP <a href="http://alisothegeek.com/2011/01/wordpress-settings-api-tutorial-1/">Setting API</a></p>';
	
}	
	
}
?>